package be.iminds.ilabt.jfed.experimenter_gui.canvas.impl;

import be.iminds.ilabt.jfed.experimenter_gui.JFedConfiguration;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.ExperimentCanvas;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.TestbedAwareCanvasNode;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageUtil;
import be.iminds.ilabt.jfed.highlevel.model.AuthorityList;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXAddressPool;
import javafx.scene.image.Image;

/**
 * User: twalcari
 * Date: 10/28/2015
 * Time: 12:16
 */
public class AddressPoolCanvasNode  extends TestbedAwareCanvasNode {

    private final FXAddressPool addressPool;

    public AddressPoolCanvasNode(FXAddressPool addressPool,final ExperimentCanvas experimentCanvas, AuthorityList authorityList, JFedConfiguration config) {
        super(experimentCanvas, addressPool.getClientId(),
                new Image(ImageUtil.class.getResource("/images/node_types/32/addresspool.png").toExternalForm()),
                authorityList, config);
        this.addressPool = addressPool;

        textProperty().bind(addressPool.clientIdProperty());
        componentManagerId.bind(addressPool.componentManagerIdProperty());

        layoutXProperty().bindBidirectional(addressPool.editorXProperty());
        layoutYProperty().bindBidirectional(addressPool.editorYProperty());

        experimentCanvas.getCanvas().getChildren().add(this);


    }

    public FXAddressPool getAddressPool() {
        return addressPool;
    }

    /**
     * Should be called when the RspecCanvasLink is removed from the canvas
     */
    public void remove() {
        experimentCanvas.getCanvas().getChildren().remove(this);
    }
}
