package be.iminds.ilabt.jfed.experimenter_gui.editor;

import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXModelRspec;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXRspecNode;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * User: twalcari
 * Date: 5/21/2015
 * Time: 15:42
 */
public class ModelRspecUtils {
    private static final Logger LOG = LoggerFactory.getLogger(ModelRspecUtils.class);

    /**
     * This method arranges all the nodes on an ellipse of the given width and height
     */
    public static void arrangeNodesOnCircle(FXModelRspec modelRspec, double width, double height) {
        LOG.debug("Arranging all nodes on a circle of {}x{}", width, height);
        if (width < 100.0) width = 300.0;
        if (height < 100.0) height = 300.0;

        int size = modelRspec.getNodes().size();
        double radiusW = width / 3.0; //diameter of 2/3 width
        double radiusH = height / 3.0; //diameter of 2/3 height

        double centerX = width / 2.0;
        double centerY = height / 2.0;
        double angle = 0.0;
        double step = (2 * Math.PI) / size;
        for (FXRspecNode n : modelRspec.getNodes()) {
            double x = (Math.cos(angle) * radiusW) + centerX;
            double y = (Math.sin(angle) * radiusH) + centerY;

            x -= 90;
            y -= 15;

            n.setEditorX(x);
            n.setEditorY(y);

            angle += step;
        }
    }
}
