package be.iminds.ilabt.jfed.highlevel;

import be.iminds.ilabt.jfed.lowlevel.GeniUser;
import be.iminds.ilabt.jfed.lowlevel.GeniUserProvider;
import be.iminds.ilabt.jfed.lowlevel.authority.AuthorityFinder;
import be.iminds.ilabt.jfed.lowlevel.authority.AuthorityListModel;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedConnectionProvider;
import be.iminds.ilabt.jfed.lowlevel.userloginmodel.UserLoginModelManager;
import be.iminds.ilabt.jfed.preferences.JFedPreferences;
import be.iminds.ilabt.jfed.util.JavaFXLogger;
import com.google.inject.AbstractModule;
import com.google.inject.Provides;

import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 11/27/2014
 * Time: 16:34
 */
public class UserLoginModelModule extends AbstractModule{
    @Provides @Singleton
    public UserLoginModelManager provideUserLoginModelManager(AuthorityListModel authorityListModel,
                                                              AuthorityFinder authorityFinder,
                                                              JavaFXLogger logger,
                                                              JFedConnectionProvider connectionProvider, JFedPreferences jFedPreferences){
        UserLoginModelManager userLoginModelManager = new UserLoginModelManager(authorityListModel, authorityFinder, logger,
                connectionProvider, jFedPreferences);
        userLoginModelManager.load();
        return userLoginModelManager;
    }

    @Provides
    private GeniUser provideGeniUser(GeniUserProvider userProvider) {
        return userProvider.getLoggedInGeniUser();
    }

    @Override
    protected void configure() {
          bind(GeniUserProvider.class).to(UserLoginModelManager.class).in(Singleton.class);
    }
}
