package be.iminds.ilabt.jfed.lowlevel.connection;

import org.apache.http.Header;
import org.apache.http.StatusLine;
import org.apache.xmlrpc.XmlRpcTransport;
import org.apache.xmlrpc.XmlRpcTransportFactory;

import java.util.List;

/**
 * HttpInfoXmlRpcTransportFactory
 */
public interface HttpInfoXmlRpcTransportFactory extends XmlRpcTransportFactory {
    /**
     * debug mode will print out a info during the call
     */
    boolean isDebugMode();

    /**
     * debug mode will print out a info during the call
     */
    void setDebugMode(boolean debug);

    String getHttpReceivedHistory();

    String getHttpSentHistory();

    StatusLine getHttpStatusLine();

    String getHttpRequestLine();

    String getHttpRequestHeaders();

    String getHttpResponseHeaders();

    List<Header> getRawHttpResponseHeaders();

    void clearLastCallData();

    void close();

    XmlRpcTransport createTransport() throws org.apache.xmlrpc.XmlRpcClientException;

    void setProperty(String s, Object o);

    public static class HttpServerErrorException extends Exception {
        private int statusNr;
        private String reason;

        public HttpServerErrorException(int statusNr, String reason) {
            super("HTTP Server is busy");
            this.statusNr = statusNr;
            this.reason = reason;
        }

        public int getStatusNr() {
            return statusNr;
        }

        public String getReason() {
            return reason;
        }
    }
}
